/*
	bone_ppp_pap.h

	PPP PAP (Password Authentication Protocol) module

	Copyright 2001, Be Incorporated, All Rights Reserved.
*/

#ifndef H_BONE_PPP_PAP
#define H_BONE_PPP_PAP

#include <module.h>
#include <bone_util.h>
#include <bone_ppp_neg.h>

typedef struct bone_pap_auth
{
	char	peer_id[32];
	char	password[32];
} bone_pap_auth_t;

typedef struct bone_ppp_pap {
	bone_ppp_handler_t		handler;
	
	void		*cookie;
	
	status_t	(*send_data)(struct bone_ppp_pap *you, bone_data_t *data);
	bool		(*authenticate_peer)(struct bone_ppp_pap *you, const bone_pap_auth_t *auth);
	status_t	(*authenticate_local)(struct bone_ppp_pap *you, bone_pap_auth_t *auth);
} bone_ppp_pap_t;

typedef struct bone_ppp_neg_info {

	struct module_info module;
	
	status_t	(*init_pap)(struct bone_ppp_pap *pap);
	status_t	(*uninit_pap)(struct bone_ppp_pap *pap);
	
	void		(*enable_peer_auth)(struct bone_ppp_pap *pap, bool enable);
	void		(*enable_local_auth)(struct bone_ppp_pap *pap, bool enable);
} bone_ppp_neg_info_t;

#define BONE_NEG_MODULE_NAME 	"pap"
#define PAP_PROTO_TYPE 			0xC023

#endif
